<template>
    <Card>
      <p slot="title">Автопрокрутка &nbsp;&nbsp;&nbsp;<i-switch size="large" v-model="enableScroll"></i-switch> </p>
      <div>
          <log-viewer :log="log"
                      :loading="isLoading"
                      :autoScroll="enableScroll"
                      style="font-size: medium;height: 70vh"
          />
      </div>
    </Card>
</template>

<script>
import config from '@/config'

export default {
  name: 'StatusIndex',
  data () {
    return {
      log: '',
      socket: '',
      isLoading: true,
      messages: [],
      text: 'Ручной',
      enableScroll: true
    }
  },
  mounted () {
    this.init()
  },
  methods: {
    init: function () {
      let cur = this
      if (typeof (WebSocket) === 'undefined') {
        alert('Ваш браузер не поддерживает socket')
      } else {
        // Socket
        cur.socket = new WebSocket(cur.getWsAddr())
        // Socket
        cur.socket.onopen = cur.open
        // Socket
        cur.socket.onerror = cur.error
        // Socket
        cur.socket.onmessage = cur.receive
      }
    },
    open: function () {
      console.log('Успешное подключение')
    },
    error: function () {
      this.$Message.error('Ошибка подключения')
    },
    receive: function (msg) {
      let message = msg.data
      message = this.getDate() + ' ' + message
      this.log = this.log + '\n' + message
      this.messages.push(message)
    },
    send: function (params) {
      this.socket.send(params)
    },
    close: function () {
      console.log('Закрытый')
    },
    getDate: function () {
      let today = new Date()
      let date = today.getFullYear() + '-' + (today.getMonth() + 1) + '-' + today.getDate()
      let time = today.getHours() + ':' + today.getMinutes() + ':' + today.getSeconds()
      return date + ' ' + time
    },
    getWsAddr: function () {
      let host = ''
      let wsHost = process.env.NODE_ENV === 'development' ? config.wsHost.dev : config.wsHost.pro
      if (wsHost !== undefined && wsHost.length > 0) {
        host = wsHost
      }
      if (host === 'v1') {
        host = window.location.host + '/v1'
      }

      return 'ws://' + host + '/task/status'
    }
  },
  destroyed () {
    this.socket.onclose = this.close
  }
}
</script>

<style scoped>

</style>
